<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfV_SDD_ExtratoContaERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfV_SDD_ExtratoContaERP
 * @subpackage Arrays
 */
class ArrayOfV_SDD_ExtratoContaERP extends AbstractStructArrayBase
{
    /**
     * The V_SDD_ExtratoContaERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\V_SDD_ExtratoContaERP[]
     */
    public $V_SDD_ExtratoContaERP;
    /**
     * Constructor method for ArrayOfV_SDD_ExtratoContaERP
     * @uses ArrayOfV_SDD_ExtratoContaERP::setV_SDD_ExtratoContaERP()
     * @param \StructType\V_SDD_ExtratoContaERP[] $v_SDD_ExtratoContaERP
     */
    public function __construct(array $v_SDD_ExtratoContaERP = array())
    {
        $this
            ->setV_SDD_ExtratoContaERP($v_SDD_ExtratoContaERP);
    }
    /**
     * Get V_SDD_ExtratoContaERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\V_SDD_ExtratoContaERP[]|null
     */
    public function getV_SDD_ExtratoContaERP()
    {
        return isset($this->V_SDD_ExtratoContaERP) ? $this->V_SDD_ExtratoContaERP : null;
    }
    /**
     * Set V_SDD_ExtratoContaERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\V_SDD_ExtratoContaERP[] $v_SDD_ExtratoContaERP
     * @return \ArrayType\ArrayOfV_SDD_ExtratoContaERP
     */
    public function setV_SDD_ExtratoContaERP(array $v_SDD_ExtratoContaERP = array())
    {
        foreach ($v_SDD_ExtratoContaERP as $arrayOfV_SDD_ExtratoContaERPV_SDD_ExtratoContaERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfV_SDD_ExtratoContaERPV_SDD_ExtratoContaERPItem instanceof \StructType\V_SDD_ExtratoContaERP) {
                throw new \InvalidArgumentException(sprintf('The V_SDD_ExtratoContaERP property can only contain items of \StructType\V_SDD_ExtratoContaERP, "%s" given', is_object($arrayOfV_SDD_ExtratoContaERPV_SDD_ExtratoContaERPItem) ? get_class($arrayOfV_SDD_ExtratoContaERPV_SDD_ExtratoContaERPItem) : gettype($arrayOfV_SDD_ExtratoContaERPV_SDD_ExtratoContaERPItem)), __LINE__);
            }
        }
        if (is_null($v_SDD_ExtratoContaERP) || (is_array($v_SDD_ExtratoContaERP) && empty($v_SDD_ExtratoContaERP))) {
            unset($this->V_SDD_ExtratoContaERP);
        } else {
            $this->V_SDD_ExtratoContaERP = $v_SDD_ExtratoContaERP;
        }
        return $this;
    }
    /**
     * Add item to V_SDD_ExtratoContaERP value
     * @throws \InvalidArgumentException
     * @param \StructType\V_SDD_ExtratoContaERP $item
     * @return \ArrayType\ArrayOfV_SDD_ExtratoContaERP
     */
    public function addToV_SDD_ExtratoContaERP(\StructType\V_SDD_ExtratoContaERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\V_SDD_ExtratoContaERP) {
            throw new \InvalidArgumentException(sprintf('The V_SDD_ExtratoContaERP property can only contain items of \StructType\V_SDD_ExtratoContaERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->V_SDD_ExtratoContaERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\V_SDD_ExtratoContaERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\V_SDD_ExtratoContaERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\V_SDD_ExtratoContaERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\V_SDD_ExtratoContaERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\V_SDD_ExtratoContaERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string V_SDD_ExtratoContaERP
     */
    public function getAttributeName()
    {
        return 'V_SDD_ExtratoContaERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfV_SDD_ExtratoContaERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
